//#define MY_INTERNAL_TEMP // дефайн активирующий код для внутренней температуры чипа

// Enable debug prints to serial monitor
//#define MY_DEBUG
#ifndef MY_DEBUG
#define MY_DISABLED_SERIAL // NRF_UART0->ENABLE = 0; использовать совсем не обязательно, тк MY_DISABLED_SERIAL как раз делает NRF_UART0->ENABLE = 0 внутри библы
#endif


// Enable and select radio type attached
#define MY_RADIO_NRF5_ESB
#define MY_NRF5_ESB_PA_LEVEL (NRF5_PA_MAX)

#define MY_NODE_ID 60
//#define MY_PARENT_NODE_ID AUTO  // так это не работает, если этот дефайн не активировать то внутри библы он и так АВТО

#define SN "MySensors_BME280_52_V4"
#define SV "1.8.7"

#define CHILD_ID_TEMP 0
#define CHILD_ID_HUM 1
#define CHILD_ID_PRESSURE 2
#define BATTERY_VOLTAGE_ID 3  //вольтаж батарейки
#define SIGNAL_Q_ID 253 //сенсор уровня сигнала
#ifdef MY_INTERNAL_TEMP
#define TEMP_CHILD_ID 252 //сенсор температуры чипа
#endif

#define ON 0
#define OFF 1

//################################### ВРЕМЯ СНА #########################################
//unsigned long SLEEP_TIME = 600000; // репорт сенсора раз в 10 минут
unsigned long SLEEP_TIME = 60000; // репорт сенсора раз в 1 минуту
//unsigned long BATT_TIME = 6; // репорт батарейки раз в 6 часов
unsigned int BATT_TIME = 1; // репорт батарейки раз в 1 час
unsigned long battInt; // сколько нужно циклов сна что бы получилось время в часах в BATT_TIME
unsigned long battCheck; // счетчик циклов сна, для выдерживания интервалов репортов батарейки
//#######################################################################################

#ifdef MY_INTERNAL_TEMP
uint32_t rawTemperature = 0;
float celsius = 0.0; //rawTemperature converted to Celsius
#endif
static uint8_t led_pin = 5;
uint8_t set_led;

bool check; // флаг удачной отправки сообщений
bool pch; // флаг готовности данных с давлением
bool tch; // флаг готовности данных с температурой
bool hch; // флаг готовности данных с влажностью
bool bch; // флаг готовности данных с батарейкой

uint8_t battery; // переменная для значений батарейки в процентах
uint8_t old_battery = 255; // переменная для старого значений батарейки в процентах
int16_t nRFRSSI; // переменная для значений уровня сигнала

uint16_t batteryVoltage; // переменная для значений батарейки
float batteryVoltageF; // переменная для значений батарейки пересчитанное в mV

#include <MySensors.h>

MyMessage msgHum(CHILD_ID_HUM, V_HUM);
MyMessage msgPress(CHILD_ID_PRESSURE, V_PRESSURE);
MyMessage msgTemp(CHILD_ID_TEMP, V_TEMP);
MyMessage bvMsg(BATTERY_VOLTAGE_ID, V_VAR1);
MyMessage sqMsg(SIGNAL_Q_ID, V_VAR1);
#ifdef MY_INTERNAL_TEMP
MyMessage msg3(TEMP_CHILD_ID, V_TEMP);
#endif

#include <Wire.h>

#include <BME280I2C.h>
// датчик температуры, давления и влажности
BME280I2C bme;

float humThreshold = 2.5;
float presThreshold = 1.5;
float tempThreshold = 0.5;
float temp, hum, pres, oldTemp, oldHum, oldPres;

void preHwInit() {

  pinMode(21, INPUT);
  pinMode(led_pin, OUTPUT);
  digitalWrite(led_pin, OFF);
}

void presentation()
{
  check = sendSketchInfo(SN, SV);
  if (!check) {
    _transportSM.failedUplinkTransmissions = 0;  // обнуляем стандартный каунтер неудачных отправок
    wait(50);
    check = sendSketchInfo(SN, SV);
    wait(50);
    if (!check) {
      _transportSM.failedUplinkTransmissions = 0; // обнуляем стандартный каунтер неудачных отправок
      wait(100);
      check = sendSketchInfo(SN, SV);
      wait(100);
    }
  }

  check = present(CHILD_ID_TEMP, S_TEMP, "Temperature sensor");
  if (!check) {
    _transportSM.failedUplinkTransmissions = 0;
    wait(75);
    check = present(CHILD_ID_TEMP, S_TEMP, "Temperature sensor");
    wait(75);
    _transportSM.failedUplinkTransmissions = 0;
  }

  check = present(CHILD_ID_HUM, S_HUM, "Humidity sensor");
  if (!check) {
    _transportSM.failedUplinkTransmissions = 0;
    wait(100);
    check = present(CHILD_ID_HUM, S_HUM, "Humidity sensor");
    wait(100);
    _transportSM.failedUplinkTransmissions = 0;
  }

  check = present(CHILD_ID_PRESSURE, S_BARO, "Pressure sensor");
  if (!check) {
    _transportSM.failedUplinkTransmissions = 0;
    wait(125);
    check = present(CHILD_ID_PRESSURE, S_BARO, "Pressure sensor");
    wait(125);
    _transportSM.failedUplinkTransmissions = 0;
  }

#ifdef MY_INTERNAL_TEMP
  check = present(TEMP_CHILD_ID, S_TEMP, "Self Temp");
  if (!check) {
    _transportSM.failedUplinkTransmissions = 0;
    wait(150);
    check = present(TEMP_CHILD_ID, S_TEMP, "Self Temp");
    wait(150);
    _transportSM.failedUplinkTransmissions = 0;
  }
#endif

  check = present(SIGNAL_Q_ID, S_CUSTOM, "Signal Quality");
  if (!check) {
    _transportSM.failedUplinkTransmissions = 0;
    wait(175);
    check = present(SIGNAL_Q_ID, S_CUSTOM, "Signal Quality");
    wait(175);
    _transportSM.failedUplinkTransmissions = 0;
  }

  check = present(BATTERY_VOLTAGE_ID, S_CUSTOM, "Battery Voltage");
  if (!check) {
    _transportSM.failedUplinkTransmissions = 0;
    wait(200);
    check = present(BATTERY_VOLTAGE_ID, S_CUSTOM, "Battery Voltage");
    wait(200);
    _transportSM.failedUplinkTransmissions = 0;
  }
}


void before()
{
  NRF_POWER->DCDCEN = 1;              // режим пониженного потребления при передаче данных - 50%
#ifdef MY_INTERNAL_TEMP
  NRF_CLOCK->TASKS_HFCLKSTART = 1;
  NRF_TEMP->TASKS_STOP;
  NRF_TEMP->EVENTS_DATARDY = 0;
  NRF_TEMP->INTENSET = 1;
  while (!(NRF_TEMP->INTENSET == 1)) {}
#endif

  battInt = BATT_TIME * 60 * 60000 / SLEEP_TIME;  // посчитаем сколько там надо пропустить циклов сна для репорта батарейки

}

void setup()
{
  digitalWrite(led_pin, ON);
  wait(200);
  digitalWrite(led_pin, OFF);
  wait(50);
  digitalWrite(led_pin, ON);
  wait(200);
  digitalWrite(led_pin, OFF);
  wait(1000);

  disableNfc();
  turnOffAdc();
  bme.begin();
  wait(200);
  
   readBatt(); // чтение заряда батарейки
}


void loop()
{
  //####################### INTERAL VOLTAGE READ + BATTERY PERSENTAGE CONVERT #############################
  battCheck++; // счетчик интервала отправки батарейки
  if (battCheck == battInt) {
    readBatt();
    battCheck = 0;
  }


  //################################### BME 280 READ, CHECK & SEND ########################################
  bme.read(pres, temp, hum, true, B101);
  
  if (abs(pres - oldPres) >= presThreshold) {
    oldPres = pres;
    pch = true;
  }

  if(abs(temp - oldTemp) >= tempThreshold) {
    oldTemp = temp;
    tch = true;
  }

  if (abs(hum - oldHum) >= humThreshold) {
    oldHum = hum;
    hch = true;
  }


  if (hch == true) {
    check = send(msgHum.set(hum, 1));
    if (!check) {
      _transportSM.failedUplinkTransmissions = 0;
      wait(50);
      check = send(msgHum.set(hum, 1));
      wait(50);
      _transportSM.failedUplinkTransmissions = 0;
    }
    hch = false;
    CORE_DEBUG(PSTR("MyS: SEND HUMIDITY\n"));
  }

  if (pch == true) {
    check = send(msgPress.set(pres, 1));
    if (!check) {
      _transportSM.failedUplinkTransmissions = 0;
      wait(75);
      check = send(msgPress.set(pres, 1));
      wait(75);
      _transportSM.failedUplinkTransmissions = 0;
    }
    pch = false;
    CORE_DEBUG(PSTR("MyS: SEND PRESSURE\n"));
  }

  if (tch == true) {
    check = send(msgTemp.set(temp, 1));
    if (!check) {
      _transportSM.failedUplinkTransmissions = 0;
      wait(100);
      check = send(msgTemp.set(temp, 1));
      wait(100);
      _transportSM.failedUplinkTransmissions = 0;
    }
    tch = false;
    CORE_DEBUG(PSTR("MyS: SEND TEMPERATURE\n"));
  }


  //####################################### INTERAL TEMP #############################################
#ifdef MY_INTERNAL_TEMP
  readTemp(); // меряем и отправляем температуру, НО зачем если есть bme280?
#endif


  //######################### BATTERY SEND INTERAL VOLTAGE SEND + LQ #################################
  if (bch == 1) { // если есть новые данные о заряде батарейки то делаем отправку
    batLevSend();
    bch = 0;
  }


  //######################################## SWEET DREAM #############################################
  sleep(SLEEP_TIME, false); // обычный сон без смарт слипа
}

#ifdef MY_INTERNAL_TEMP
void readTemp() {
  NRF_TEMP->TASKS_START = 1;
  while (!(NRF_TEMP->EVENTS_DATARDY)) {}
  rawTemperature = NRF_TEMP->TEMP;
  celsius = ((float)rawTemperature) / 4.0;
  check = send(msg3.set(celsius, 2), true);
  wait(250);
  if (!check) {
    _transportSM.failedUplinkTransmissions = 0;
    check = send(msg3.set(celsius, 2), true);
    wait(500);
    _transportSM.failedUplinkTransmissions = 0;
  } else {
    CORE_DEBUG(PSTR("MyS: SEND TEMPERATURE ON CHIP\n"));
  }
  if (set_led == 1) {
    digitalWrite(led_pin, ON);
    wait(50);
    digitalWrite(led_pin, OFF);
  }
}
#endif

void disableNfc() {  //only applied to nRF52
  //Make pins 9 and 10 usable as GPIO pins.
  NRF_NFCT->TASKS_DISABLE = 1; //disable NFC
  NRF_NVMC->CONFIG = 1; // Write enable the UICR
  NRF_UICR->NFCPINS = 0; //Make pins 9 and 10 usable as GPIO pins.
  NRF_NVMC->CONFIG = 0; // Put the UICR back into read-only mode.
}

void turnOffAdc() {
  if (NRF_SAADC->ENABLE) { //if enabled, then disable the SAADC
    NRF_SAADC->TASKS_STOP = 1;
    while (NRF_SAADC->EVENTS_STOPPED) {} //wait until stopping of SAADC is confirmed
    NRF_SAADC->ENABLE = 0; //disable the SAADC
    while (NRF_SAADC->ENABLE) {} //wait until the disable is confirmed
  }
}


//########################################## BATTARY MAGIC ###################################################

void readBatt() {
  batteryVoltage = hwCPUVoltage();
  battery = battery_level_in_percent(batteryVoltage);
  batteryVoltageF = (float)batteryVoltage / 1000.00;
  CORE_DEBUG(PSTR("battery voltage: %d\n"), batteryVoltage);
  CORE_DEBUG(PSTR("battery percentage: %d\n"), battery);
  bch = 1;
}


void batLevSend() {
  if (battery > 100) {
    battery = 100;
  }
  if (battery < old_battery) { // если только меньше предыдущего, закоментить если не нужно сравнение
    check = sendBatteryLevel(battery, 1);
    wait(500);
    if (!check) {
      _transportSM.failedUplinkTransmissions = 0;
      check = sendBatteryLevel(battery, 1);
      wait(500);
      _transportSM.failedUplinkTransmissions = 0;
    } else {
      CORE_DEBUG(PSTR("MyS: SEND BATTERY VOLTAGE\n"));
    }

    check = send(bvMsg.set(batteryVoltageF, 2));
    if (!check) {
      _transportSM.failedUplinkTransmissions = 0;
      wait(100);
      check = send(bvMsg.set(batteryVoltageF, 2));
      _transportSM.failedUplinkTransmissions = 0;
      wait(100);
    } else {
      CORE_DEBUG(PSTR("MyS: SEND BATTERY VOLTAGE\n"));
    }
    old_battery = battery; // если только меньше предыдущего, закоментить если не нужно сравнение
  } // если только меньше предыдущего, закоментить если не нужно сравнение
  lqSend();
}


void lqSend() {
  nRFRSSI = transportGetReceivingRSSI();
  nRFRSSI = map(nRFRSSI, -85, -40, 0, 100);
  if (nRFRSSI < 0) {
    nRFRSSI = 0;
  }
  if (nRFRSSI > 100) {
    nRFRSSI = 100;
  }
  check = send(sqMsg.set(nRFRSSI));
  if (!check) {
    _transportSM.failedUplinkTransmissions = 0;
    wait(100);
    check = send(sqMsg.set(nRFRSSI));
    _transportSM.failedUplinkTransmissions = 0;
  } else {
    CORE_DEBUG(PSTR("MyS: SEND LINK QUALITY\n"));
    CORE_DEBUG(PSTR("MyS: LINK QUALITY %: %d\n"), nRFRSSI);
  }
}

static __INLINE uint8_t battery_level_in_percent(const uint16_t mvolts)
{
  uint8_t battery_level;

  if (mvolts >= 3000)
  {
    battery_level = 100;
  }
  else if (mvolts > 2900)
  {
    battery_level = 100 - ((3000 - mvolts) * 46) / 100;
  }
  else if (mvolts > 2740)
  {
    battery_level = 54 - ((2900 - mvolts) * 32) / 160;
  }
  else if (mvolts > 2440)
  {
    battery_level = 22 - ((2740 - mvolts) * 16) / 300;
  }
  else if (mvolts > 2100)
  {
    battery_level = 6 - ((2440 - mvolts) * 6) / 340;
  }
  else
  {
    battery_level = 0;
  }

  return battery_level;
}
